#!/usr/local/bin/perl

$savehostname=0;  # save(1) or omit(0) hostname

sub getsavefilename
{
    local($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) =localtime(time());
    local($fname);
    $fname=sprintf("%02d%02d%02d-%02d%02d",$year,$mon +1,$mday,$hour,$min);
    return $fname;
}
sub printpacket
{
    local($time,*packetcount,*packetsize) = @_;
    foreach $packet(sort keys %packetsize){
	print "$time,$packet,$packetcount{$packet},$packetsize{$packet}\n";
    }
}
{
    $oldtime=0;
    $oldfname="";
    $oldtime2=0;
	$|=1;
    local(%packetsize);
    &printpacket($time,$packetsize);
    while(<>)
    {
	if(/^:/){next;}
	local($ipproto,$fromhost,$fromport,$tohost,$toport,$size)=split(/,/);
	$time=time;
	if($time != $oldtime){
	    $time2=&getsavefilename;
	    if($oldtime2 ne $time2){
		&printpacket($time2,*packetcount,*packetsize);
	        undef %packetsize;
	        undef %packetcount;

		$oldtime2=$time2;
	    }
	    $oldtime=$time;
	}
				# 2049 = NFS
	if(($fromport >=1024 && $fromport <4096 && $fromport!=2049) || $fromport=~ /^[0-9a-f]{6,}$/){
	    $fromport="client";
	}
	if(($toport >=1024 && $toport <4096 && $toport!=2049) || $toport=~ /^[0-9a-f]{6,}$/){
	    $toport="client";
	}
	if($fromport eq "nfs"){$toport="client";}
	if($toport eq "nfs"){$fromport="client";}

	if($savehostname){
	    $packet="$ipproto,$fromhost,$fromport,$tohost,$toport";
	}else{
	    $packet="$ipproto,,$fromport,,$toport";
	}
	$packetsize{$packet} += $size;
	$packetcount{$packet} += 1;
    }
    print STDERR "End of File!\n";
    &printpacket($time2,*packetcount,*packetsize);
}










